# Oh! Mz 1989年2月号再掲載版 X1版Sword

- [Oh! Mz 1989年2月号再掲載版 X1版Sword](#oh-mz-1989年2月号再掲載版-x1版sword)
  - [はじめに](#はじめに)
  - [免責事項](#免責事項)
  - [内容物](#内容物)
  - [Oh! Mz 1989年2月号再掲載版 X1版 Sword起動ディスク作成手順](#oh-mz-1989年2月号再掲載版-x1版-sword起動ディスク作成手順)
    - [X1版SwordとFormat and Sysgenバイナリファイルとをディスクへ格納](#x1版swordとformat-and-sysgenバイナリファイルとをディスクへ格納)
      - [実機を利用する場合](#実機を利用する場合)
      - [エミュレータを利用する場合](#エミュレータを利用する場合)
    - [X1版Swordシステムディスクの作成](#x1版swordシステムディスクの作成)
  - [ロード先メモリの確保](#ロード先メモリの確保)
  - [sword.binとfmtsgen.binのロード](#swordbinとfmtsgenbinのロード)
  - [Hu-Monitor(Hu-Basicのモニタ)の呼び出し](#hu-monitorhu-basicのモニタの呼び出し)
  - [実行時アドレスへの転送](#実行時アドレスへの転送)
  - [Swordのコールドスタート呼び出し](#swordのコールドスタート呼び出し)
  - [システムディスクの作成](#システムディスクの作成)
  - [エミュレータ関連ツール](#エミュレータ関連ツール)
  - [付録 X1Sword.d88イメージファイルの作成方法](#付録-x1swordd88イメージファイルの作成方法)
      - [X1用ブランクディスクを作成](#x1用ブランクディスクを作成)
      - [SwordとFormat\&Sysgenを保存](#swordとformatsysgenを保存)

## はじめに

本アーカイブは, Oh! Mz 1989年2月号掲載されたX1版Swordのバイナリイメージを格納しています。本手順書では, 本アーカイブ同梱のX1版Swordのバイナリイメージを用いて, X1版Swordの起動ディスクを作成する手順を説明します。

X1の実機, または, X1エミュレータ上で, Disk版 Hu-Basic V1.0(CZ-8FB01 V1.0)を実行し, 本アーカイブに同梱のバイナリイメージを使用することで, X1版 Swordの起動ディスクを作成することが可能です。

## 免責事項

1．情報の正確性について
本アーカイブ内の内容物について, 可能な限り正確な情報を格納するよう努めています。しかし, 誤解やタイプミスなどに伴う誤り等により, 正確な情報を記載できていない可能性があることをご了承ください。また合法性や安全性なども保証しません。

2．損害等の責任について
アーカイブ内の内容物の直接・間接的な利用によって生じた損害等の一切の責任を負いかねますので、ご了承ください。

## 内容物

本アーカイブには以下のファイルが含まれています。

|ファイル名|内容|
|---|---|
|binaries\sword.bin|Oh! Mz 1989年2月号掲載 X1版 Swordのダンプリストをファイルの先頭から入力したバイナリファイル|
|binaries\fmtsgen.bin|Oh! Mz 1989年2月号掲載 Format and Sysgenのダンプリストをファイルの先頭から入力したバイナリファイル|
|disk\X1Sword.d88|上記のsword.binとfmtsgen.binを格納したX1 2D ディスク Hu-BasicフォーマットのD88イメージファイル。|
|Install.pdf|本手順書のpdfファイル|
|Install.md|本手順書のMarkdown形式のテキストファイル|
|images\ |本手順書の画像ファイル格納ディレクトリ|

## Oh! Mz 1989年2月号再掲載版 X1版 Sword起動ディスク作成手順

本作業には, X1の実機またはエミュレータ上で動作するHu-Basic CZ-8FB01 V1.0が必要となりますので, 別途ご用意ください。

なお, 入力先アドレスをclear文で確保する関係上, 本作業で使用するHu-Basicのバージョンは V1.0である必要があることに留意ください(Hu-Basic CZ-8FB01 V2.0 (New Basic)では以下の手順ではSwordの導入は不可能です)。

また, システムディスク作成用にX1用2Dディスク形式のブランクディスクが必要です。エミュレータを使用する場合は, [付録 X1Sword.d88イメージファイルの作成方法](#付録-x1swordd88イメージファイルの作成方法)中にある[X1用ブランクディスクの作成](#x1用ブランクディスクを作成)手順に従って, ブランクディスクのディスクイメージを作成して, ブランクディスクのディスクイメージを保存し, ブランクディスクのディスクイメージを作成してください。

X1 Swordの起動ディスク作成手順の概要を以下に示します。

1. 本アーカイブ同梱のX1版SwordとFormat and SysgenのバイナリファイルとをX1 Hu-Basicフォーマットの2Dディスクへ格納します
2. X1実機, または, エミュレータ上からX1版Swordシステムディスクを作成します

なお, 以下の手順では, メモリアドレスを16進数で記載します。

### X1版SwordとFormat and Sysgenバイナリファイルとをディスクへ格納

本節では, 本アーカイブ同梱のX1版SwordとFormat and SysgenのバイナリファイルとをX1 Hu-Basicフォーマットの2Dディスクへ格納する手順を示します。

X1の実機を利用する場合は, 同梱のバイナリファイルをX1 Hu-Basicフォーマットのディスクに格納してください。エミュレータを使用する場合は, 同梱の`disk\X1Sword.d88`を使用することができます。

#### 実機を利用する場合

実機を利用する場合は, `binaries\sword.bin`, `fmtsgen.bin`をシリアル回線などを用いて実機上にダウンロードして, X1 Hu-Basicフォーマットの2Dディスクに保存してください。

それぞれのファイルを保存する際のロード開始アドレス, 実行アドレスは以下のように設定してください。以下では, 各アドレスを16進数で表記しています。

本手順書では, 作業誤りを防止するために, 1989年2月号のOh!Mzでの入力開始アドレスと異なるアドレスにFormat and Sysgenのバイナリをロードするようにしています。

以下の表では, 1989年2月号のOh!Mzでの入力開始アドレスを参考に記載しています。

|ファイル名|ロード開始アドレス|終了アドレス|実行アドレス|1989年2月号のOh!Mzでの入力開始アドレス|
|---|---|---|---|---|
|sword.bin|C500|DCD4|0000|C500|
|fmtsgen.bin|E000|E25A|0000|7000|

#### エミュレータを利用する場合

エミュレータを利用する場合は, 上記のファイルを格納したX1 2D ディスク Hu-BasicフォーマットのD88イメージファイルを`disk\X1Sword.d88`に格納していますので, 当該のファイルをエミュレータのフロッピーディスクドライブイメージセットしてください。

### X1版Swordシステムディスクの作成

Swordシステムディスクの作成手順の概要は以下の通りです。

1. X1実機またはエミュレータ上でHu-Basicディスク版Hu-BASIC V1.0(CZ-8FB01 V1.0)を起動します
2. ロード先メモリを確保します
3. BASICのプロンプトからsword.binとfmtsgen.binとをメモリ上にロードします
4. Hu-Monitor(Hu-Basicのモニタ)に入ります
5. sword.binとfmtsgen.binとを実行時アドレスに転送します
6. Swordのコールドスタートを呼び出します
7. Hu-Basicフォーマットのブランクディスクをドライブ1に挿入します
8. Format and Sysgenを用いてシステムディスクを作成します

以下では2.以降の作業を記載します。

本手順書では, X1エミュレータ[eX1](http://takeda-toshiya.my.coocan.jp/x1twin/index.html)を用いて作業内容を例示します。
`eX1`の入手, 利用方法については, [Common Source Code Project](http://takeda-toshiya.my.coocan.jp/common/index.html)を参照ください。

## ロード先メモリの確保

sword.binとfmtsgen.binをメモリ上にロードするためのメモリ領域を確保します。
Basicのプロンプトから以下を入力し, B000以降のメモリを利用可能にします。

```Basic
CLEAR &HB000
```

実行例は以下の通りです。

![](./images/Install_2023-02-02-19-51-31.png)

## sword.binとfmtsgen.binのロード

フロッピーディスクドライブにsword.binとfmtsgen.binとを保存したディスクを挿入します。以下の手順では, ドライブ1にディスクを挿入している前提で手順を記載しています。

異なるドライブにディスクを挿入している場合は, ドライブ名を適宜読み替えてください。また, 前節で異なるファイル名でバイナリファイルを保存している場合は, 以下の説明のファイル名を適宜読み替えてください。

Hu-Basicのプロンプト上から以下のコマンドを実行し, ディスクの内容を確認します。

```Basic
FILES "1:"
```

実行例は以下の通りです。

![](./images/Install_2023-02-11-01-01-52.png)

`sword.bin`と`fmtsgen.bin`とが格納されていることを確認してください。

以下のコマンドを入力して, SwordとFormat and Sysgenをメモリにロードします。

```Basic
loadm "1:sword.bin"
loadm "1:fmtsgen.bin"
```

実行例は以下の通りです。

![](./images/Install_2023-02-11-01-04-46.png)

## Hu-Monitor(Hu-Basicのモニタ)の呼び出し

Basicのプロンプトから以下を入力し, モニタに入ります。

```Basic
MON
```

## 実行時アドレスへの転送

モニタのT(Transfer)コマンドを使用して, SwordとFormat and Sysgenを実行アドレスに転送します。

__本作業以降は, Basicに戻れないことに注意してください。__

本節では, 256バイト境界で転送するように最終アドレスを指定しています。Hu-Basicのセクタ長が256バイトであるためです。

T(Transfer)コマンドの書式は以下の通りです:
```Basic
T 転送元開始アドレス 転送元終了アドレス 転送サイズ
```

C500以降DCD4までに入力されているSwordを実行時の配置アドレス(1500)に転送します。

```Basic
T C500 DD00 1500
```

E000以降E25Aまでに入力されているFormat and Sysgenを実行時の配置アドレス(7000)に転送します。

```Basic
T E000 E300 7000
```

上記作業の実施例を以下に示します。

![](./images/Install_2023-02-11-01-09-43.png)

Oh!Mz 1989年2月号のSwordのソースでは, Swordの転送を行った後, コールドスタートにジャンプするために以下のコードがC4F0以降に記載されています。

```asm
21 00 C5    LD HL, C500H ;転送元開始アドレス
11 00 15    LD DE, 1500H ;転送先開始アドレス
01 00 18    LD BC, 1800H ;転送サイズ
ED B0       LDIR ; HLレジスタ値からDEレジスタ値のアドレスにBCレジスタのサイズ分転送
C3 FD 1F    JP 1FFDH ; S-OS swordのコールドスタートアドレス
```

Oh!Mz 1989年2月号では, 上記コマンドをモニタから実行することでプログラムを実行時アドレスに転送して, Swordにエントリする手順となっています。

上記コードを実行すると, ロードしたイメージの妥当性を確認する
手順を行う前にSwordにエントリするため, 本手順書では,
作業誤りを防止する観点から上記コードを使用せず, 転送処理を
モニタで実施する手順としました。

上記転送後, 以下のアドレスをモニタのD(Dump)コマンドで確認します。

|アドレス|意味|
|---|---|
|1500|X1版Swordの開始位置(実行アドレス)|
|2C80|X1版Swordの終了位置(実行アドレス)|
|7000|Format and Sysgenの開始位置(実行アドレス)|
|7200|Format and Sysgenの終了位置(実行アドレス)|

以下のコマンドを入力します。

```Basic
D 1500
D 2C80
D 7000
D 7200
```

アドレス1500番地, X1版Swordの開始位置(実行アドレス)の内容は以下のようになります。

![](./images/Install_2023-02-11-01-17-01.png)

アドレス2C80番地, X1版Swordの終了位置(実行アドレス)の内容は以下のようになります。

![](./images/Install_2023-02-11-01-18-17.png)

アドレス7000番地, Format and Sysgenの開始位置(実行アドレス)の内容は以下のようになります。

![](./images/Install_2023-02-11-01-19-16.png)

アドレス7200番地, Format and Sysgenの終了位置(実行アドレス)の内容は以下のようになります。

![](./images/Install_2023-02-11-01-20-17.png)

内容の妥当性を確認したら, 次節以降の作業を進めてください。

メモリの内容が一致していない場合は, 転送先アドレスの指定誤りなどが考えられますので, X1実機またはエミュレータを再起動し, Basicロード後の[ロード先メモリの確保](#ロード先メモリの確保)からやり直してください。

## Swordのコールドスタート呼び出し

上記作業に続いて, Swordのコールドスタートに入ります。
本作業によりBasicのディスクを破壊しないように, ドライブ0から
ディスクを抜いてから以下の作業を実施してください(`eX1`エミュレータの場合は, FD0メニューから`Eject`を選択することでディスクを取り除きます。)。

モニタのGコマンドにより, Swordのコールドスタート(1FFD)にジャンプします。

モニタから以下のように入力します。

```
G 1FFD
```

入力例は以下の通りです。

![](./images/Install_2023-02-11-01-34-07.png)

上記でリターンを押すと, 以下の通りSwordのプロンプトが表示されます。

![](./images/Install_2023-02-02-20-10-33.png)

引き続き, 次節以降の作業を進めてください。

## システムディスクの作成

Swordを起動するシステムディスクを作成するための以下の作業を実施します。

1. システムディスクのフォーマット
2. システムディスクの生成
3. Format and Sysgenの保存

X1のHu-Basicの(物理, 論理)ディスクフォーマットは, Swordのフォーマットと同じなので, 1.を実施せず, 2.から実施することも可能ですが, 標準手順に従って以下の手順を記載しています。

なお, システムディスク作成には, 連続したセクタが必要となるため, Format and Sysgenをシステムディスク作成後にディスク上のファイルに保存する手順としています。

まず, ブランクディスクをドライブ1に挿入してください。
`eX1`エミュレータの場合は, FD1メニューから`Insert`を選択し, ブランクディスクのディスクイメージをセットしてください。

次に, Swordのプロンプトから以下を実行して, Format and Sysgenを呼び出します(#はプロンプト)。

```Basic
#J 7000
```

上記を入力すると以下の画面になります。

![](./images/Install_2023-02-02-20-16-00.png)

まず, 1を入力して, ドライブ名にB:を設定し, フォーマットを行います。

![](./images/Install_2023-02-02-20-16-31.png)

上記で大文字`Y`を入力するとフォーマットが開始されます。

完了すると`Complete !`と表示され, プロンプトに戻ります。

![](./images/Install_2023-02-02-20-17-35.png)

もう一度Format and Sysgenを呼び出します(#はプロンプト)。

```Basic
#J 7000
```

2を入力して, ドライブ名にB:を設定し, システムディスクを作成します。

![](./images/Install_2023-02-02-20-18-58.png)

上記で大文字`Y`を入力すると起動ディスクの作成が開始されます。

完了すると`Complete !`と表示され, プロンプトに戻ります。

![](./images/Install_2023-02-02-20-20-18.png)

次に, Format and Sysgenをシステムディスクに保存します。
Swordのプロンプトから以下のコマンドを入力します。

```
#S B:fmtsgen.obj:7000:7300
```

![](./images/Install_2023-02-02-20-24-36.png)

保存が完了すると`Complete !`と表示されます。

![](./images/Install_2023-02-02-20-25-41.png)

作成したディスクをFD1から取り外し, FD0に入れて再起動するとSwordが立ち上がります。

Sword起動後, 以下のコマンドを入力し, Format and Sysgenが保存されていることを確認してください。

```
#D
```

![](./images/Install_2023-02-02-20-27-47.png)

以上で, 作業完了です。

## エミュレータ関連ツール

本作業では, 以下のX1エミュレータ, コンパチブルIPL ROM, およびディスク操作用のツールを使用させていただきました。開発関係者に感謝の意を表します。

|ソフトウエア|URL|
|---|---|
|X1エミュレータ|http://takeda-toshiya.my.coocan.jp/x1twin/index.html|
|X1コンパチブルIPL ROM|https://github.com/meister68k/|X1_compatible_rom|
|L3ディスクエクスプローラ|https://ja.osdn.net/users/bml3mk5/pf/L3DiskEx/wiki/FrontPage|

本作業について, [S-OSのページ](http://www.retropc.net/ohishi/s-os/)のOh!石様のご協力を頂きましたので感謝の意を表します。

## 付録 X1Sword.d88イメージファイルの作成方法

本節では, 本アーカイブ同梱の`X1Sword.d88`イメージファイルの作成方法について説明します。`X1Sword.d88`イメージファイルの作成手順は以下の通りです。

本作業には, [L3ディスクエクスプローラ](https://ja.osdn.net/users/bml3mk5/pf/L3DiskEx/wiki/FrontPage)が必要となりますので, 適宜ダウンロード, インストールの上, 以下の作業を実施してください。

1. X1用ブランクディスクを作成します
2. SwordとFormat&Sysgenを保存します

#### X1用ブランクディスクを作成

L3ディスクエクスプローラで新規ディスクを作成します。
以下のカテゴリー選択ダイアログ中のプルダウンメニューでシャープX1 Hu-BASICを選択してください。

![](./images/Install_2023-02-02-18-40-31.png)

設定値が以下の画面のようになっていることを確認してください。

![](./images/Install_2023-02-02-18-13-53.png)

その後, 左側のペインで, 右クリックし, `BASIC用にフォーマット`を選択します。

![](./images/Install_2023-02-02-18-17-56.png)

BASIC種類の選択で, `X1 Hu-BASIC(3インチ/5インチ2D)`を選択します。フォーマット開始の問い合わせに`はい`を選択してください。

保存ボタンを押して, 保存するファイル名を`X1Sword.d88`に指定してディスクイメージを保存してください。

上記作業後, 次節以降の作業を続けて行ってください。

#### SwordとFormat&Sysgenを保存

L3ディスクエクスプローラーを用いて, sword.binとfmtsgen.binをそれぞれ以下のパラメタで保存します。これらのファイルは, BASICからロードし, Sysgenまでを行うために, 実行時の配置先とは異なるアドレスに配置します。設定値は以下の通りです。

|ファイル名|開始アドレス|実行アドレス|
|---|---|---|
|sword.bin|C500|0000|
|fmtsgen.bin|E000|0000|

実行アドレスには0番地を指定します。これは, Basicからこれらのバイナリを読み込んだ際の操作誤り等により本ファイルを実行してしまった場合でも, Basicのコールドスタートにジャンプすることで, ロードした内容を保持したままBasicのプロンプトに復帰可能とするためです。

L3ディスクエクスプローラー上の`sword.bin`の設定値は以下の通りです。

![](./images/Install_2023-02-11-00-46-28.png)

L3ディスクエクスプローラー上の`fmtsgen.bin`の設定値は以下の通りです。

![](./images/Install_2023-02-11-00-47-39.png)

上記2つのファイルを保存後の状態は以下の通りになります。

![](./images/Install_2023-02-11-00-48-21.png)

上記を実施後, 保存ボタンを押してディスクイメージを更新して作業完了です。
